a89910911

CentOS6.5 下编译安装php-5.6.3.tar.gz



 

一、安装相关依赖库 
    yum -y install gcc gcc-c++ autoconf libjpeg libjpeg-devel libpng libpng-devel freetype freetype-devel libxml2 libxml2-devel glibc glibc-devel glib2 glib2-devel bzip2 bzip2-devel curl curl-devel openssl openssl-devel openldap openldap-devel nss_ldap openldap-clients openldap-servers pcre pcre-devel 
二、解压php包 
tar -zxvf php-5.6.3.tar.gz 
cd php-5.6.3 
export LD_LIBRARY_PATH=/usr/local/libgd/lib 
三、编译安装 
./configure --prefix=/usr/local/php --with-config-file-path=/usr/local/php/etc/ --with-mysql=/usr/local/mysql --with-mysql-sock=/usr/local/mysql/mysql.sock  --with-apxs2=/usr/local/apache/bin/apxs --with-gd --with-jpeg-dir --with-png-dir --enable-mbstring --enable-xml --enable-fpm --with-freetype-dir --with-mcrypt --with-mhash --with-libxml-dir --with-zlib-dir 
make 
make install 
四、配置php 
cp php.ini-production /usr/local/php/etc/php.ini #复制php配置文件到安装目录 
===> 
我安装的时候,放到这里不起作用,移动到/usr/local/php/lib 下,正常 

rm -rf /etc/php.ini #删除系统自带配置文件 
ln -s /usr/local/php/etc/php.ini /etc/php.ini #添加软链接到 /etc目录 
vi /etc/php.ini 
找到:disable_functions = 
修改为:disable_functions = passthru,exec,system,chroot,scandir,chgrp,chown,shell_exec,proc_open,proc_get_status,ini_alter,ini_alter,ini_restore,dl,openlog,syslog,readlink,symlink,popepassthru,stream_socket_server,escapeshellcmd,dll,popen,disk_free_space,checkdnsrr,checkdnsrr,getservbyname,getservbyport,disk_total_space,posix_ctermid,posix_get_last_error,posix_getcwd, posix_getegid,posix_geteuid,posix_getgid, posix_getgrgid,posix_getgrnam,posix_getgroups,posix_getlogin,posix_getpgid,posix_getpgrp,posix_getpid, posix_getppid,posix_getpwnam,posix_getpwuid, posix_getrlimit, posix_getsid,posix_getuid,posix_isatty, posix_kill,posix_mkfifo,posix_setegid,posix_seteuid,posix_setgid, posix_setpgid,posix_setsid,posix_setuid,posix_strerror,posix_times,posix_ttyname,posix_uname 
#列出PHP可以禁用的函数,如果某些程序需要用到这个函数,可以删除,取消禁用。 
找到:;date.timezone = 
修改为:date.timezone = PRC #设置时区 
找到:expose_php = On 
修改为:expose_php = Off #禁止显示php版本的信息 
找到:short_open_tag = Off 
修改为:short_open_tag = ON #支持php短标签 
:wq! 保存 


cp /usr/local/php/etc/php-fpm.conf.default /usr/local/php/etc/php-fpm.conf #拷贝模板文件为php-fpm配置文件 
ln -s /usr/local/php/etc/php-fpm.conf /etc/php-fpm.conf #添加软连接到 /etc目录 
vi /usr/local/php/etc/php-fpm.conf #编辑 
user = www #设置php-fpm运行账号为www 
group = www #设置php-fpm运行组为www 
pid = run/php-fpm.pid #取消前面的分号 
:wq! #保存退出 

cp /home/php-5.6.3/sapi/fpm/init.d.php-fpm /etc/rc.d/init.d/php-fpm #拷贝php-fpm到启动目录 
chmod +x /etc/rc.d/init.d/php-fpm #添加执行权限 
chkconfig php-fpm on #设置开机启动 
编辑apache配置文件httpd.conf,以apache支持php 
# vim /etc/httpd/httpd.conf 
添加如下 

AddType application/x-httpd-php .php .phtml 
定位至DirectoryIndex index.html 

修改为: 
DirectoryIndex index.php index.html 
添加index.php为默认主页 
重新启动apache 
五、测试 
在/usr/local/apache/htdocs目录下建一个test.php或test.phtml的文件,内容如下示: 
<</FONT> 

php 
phpinfo(); 


:wq! #保存退出 

======================================================= 

./configure --prefix=/usr/local/php --with-config-file-path=/usr/local/php/etc --enable-fpm --with-fpm-user=php-fpm --with-fpm-group=php-fpm --with-libxml-dir --with-gd --with-jpeg-dir --with-png-dir --with-freetype-dir --with-iconv-dir --with-zlib-dir --with-mcrypt --enable-soap --enable-gd-native-ttf --enable-ftp --enable-mbstring --enable-exif --disable-ipv6 --with-pear --with-curl --with-openssl

CentOS6.5 下编译安装php-5.6.3.tar.gz


 

一、安装相关依赖库 
    yum -y install gcc gcc-c++ autoconf libjpeg libjpeg-devel libpng libpng-devel freetype freetype-devel libxml2 libxml2-devel glibc glibc-devel glib2 glib2-devel bzip2 bzip2-devel curl curl-devel openssl openssl-devel openldap openldap-devel nss_ldap openldap-clients openldap-servers pcre pcre-devel
二、解压php包 
tar -zxvf php-5.6.3.tar.gz
cd php-5.6.3
export LD_LIBRARY_PATH=/usr/local/libgd/lib
三、编译安装 
./configure --prefix=/usr/local/php --with-config-file-path=/usr/local/php/etc/ --with-mysql=/usr/local/mysql --with-mysql-sock=/usr/local/mysql/mysql.sock  --with-apxs2=/usr/local/apache/bin/apxs --with-gd --with-jpeg-dir --with-png-dir --enable-mbstring --enable-xml --enable-fpm --with-freetype-dir --with-mcrypt --with-mhash --with-libxml-dir --with-zlib-dir 
make
make install
四、配置php
cp php.ini-production /usr/local/php/etc/php.ini #复制php配置文件到安装目录 
===> 
我安装的时候,放到这里不起作用,移动到/usr/local/php/lib 下,正常 

rm -rf /etc/php.ini #删除系统自带配置文件 
ln -s /usr/local/php/etc/php.ini /etc/php.ini #添加软链接到 /etc目录 
vi /etc/php.ini 
找到:disable_functions = 
修改为:disable_functions = passthru,exec,system,chroot,scandir,chgrp,chown,shell_exec,proc_open,proc_get_status,ini_alter,ini_alter,ini_restore,dl,openlog,syslog,readlink,symlink,popepassthru,stream_socket_server,escapeshellcmd,dll,popen,disk_free_space,checkdnsrr,checkdnsrr,getservbyname,getservbyport,disk_total_space,posix_ctermid,posix_get_last_error,posix_getcwd, posix_getegid,posix_geteuid,posix_getgid, posix_getgrgid,posix_getgrnam,posix_getgroups,posix_getlogin,posix_getpgid,posix_getpgrp,posix_getpid, posix_getppid,posix_getpwnam,posix_getpwuid, posix_getrlimit, posix_getsid,posix_getuid,posix_isatty, posix_kill,posix_mkfifo,posix_setegid,posix_seteuid,posix_setgid, posix_setpgid,posix_setsid,posix_setuid,posix_strerror,posix_times,posix_ttyname,posix_uname
#列出PHP可以禁用的函数,如果某些程序需要用到这个函数,可以删除,取消禁用。 
找到:;date.timezone = 
修改为:date.timezone = PRC #设置时区 
找到:expose_php = On
修改为:expose_php = Off #禁止显示php版本的信息 
找到:short_open_tag = Off
修改为:short_open_tag = ON #支持php短标签 
:wq! 保存 


cp /usr/local/php/etc/php-fpm.conf.default /usr/local/php/etc/php-fpm.conf #拷贝模板文件为php-fpm配置文件 
ln -s /usr/local/php/etc/php-fpm.conf /etc/php-fpm.conf #添加软连接到 /etc目录 
vi /usr/local/php/etc/php-fpm.conf #编辑 
user = www #设置php-fpm运行账号为www 
group = www #设置php-fpm运行组为www 
pid = run/php-fpm.pid #取消前面的分号 
:wq! #保存退出 

cp /home/php-5.6.3/sapi/fpm/init.d.php-fpm /etc/rc.d/init.d/php-fpm #拷贝php-fpm到启动目录 
chmod +x /etc/rc.d/init.d/php-fpm #添加执行权限 
chkconfig php-fpm on #设置开机启动 
编辑apache配置文件httpd.conf,以apache支持php
# vim /etc/httpd/httpd.conf 
添加如下 

AddType application/x-httpd-php .php .phtml 
定位至DirectoryIndex index.html

修改为: 
DirectoryIndex index.php index.html
添加index.php为默认主页 
重新启动apache
五、测试 
在/usr/local/apache/htdocs目录下建一个test.php或test.phtml的文件,内容如下示: 
<</FONT> 

php
phpinfo(); 


:wq! #保存退出 

======================================================= 

./configure --prefix=/usr/local/php --with-config-file-path=/usr/local/php/etc --enable-fpm --with-fpm-user=php-fpm --with-fpm-group=php-fpm --with-libxml-dir --with-gd --with-jpeg-dir --with-png-dir --with-freetype-dir --with-iconv-dir --with-zlib-dir --with-mcrypt --enable-soap --enable-gd-native-ttf --enable-ftp --enable-mbstring --enable-exif --disable-ipv6 --with-pear --with-curl --with-openssl


CentOS下设置nginx开机自动启动和chkconfig管理

Nginx 是一个很强大的高性能Web和反向代理服务器。虽然使用命令行可以对nginx进行各种操作,比如启动等,但是还是根据不太方便。下面介绍在Linux下安装后,如何设置开机自启动。

首先,在linux系统的/etc/init.d/目录下创建nginx文件,使用如下命令:

vim /etc/init.d/nginx

在脚本中添加如下命令:

#!/bin/sh # # nginx - this script starts and stops the nginx daemon # # chkconfig:   - 85 15 # description:  NGINX is an HTTP(S) server, HTTP(S) reverse \ #               proxy and IMAP/POP3 proxy server # processname: nginx # config:      /etc/nginx/nginx.conf # config:      /etc/sysconfig/nginx # pidfile:     /var/run/nginx.pid # Source function library. . /etc/rc.d/init.d/functions # Source networking configuration. . /etc/sysconfig/network # Check that networking is up. [ "$NETWORKING" = "no" ] && exit 0 nginx="/usr/sbin/nginx" prog=$(basename $nginx) NGINX_CONF_FILE="/etc/nginx/nginx.conf" [ -f /etc/sysconfig/nginx ] && . /etc/sysconfig/nginx lockfile=/var/lock/subsys/nginx make_dirs() {    # make required directories    user=`$nginx -V 2>&1 | grep "configure arguments:" | sed 's/[^*]*--user=\([^ ]*\).*/\1/g' -`    if [ -z "`grep $user /etc/passwd`" ]; then        useradd -M -s /bin/nologin $user    fi    options=`$nginx -V 2>&1 | grep 'configure arguments:'`    for opt in $options; do        if [ `echo $opt | grep '.*-temp-path'` ]; then            value=`echo $opt | cut -d "=" -f 2`            if [ ! -d "$value" ]; then                # echo "creating" $value                mkdir -p $value && chown -R $user $value            fi        fi    done } start() {     [ -x $nginx ] || exit 5     [ -f $NGINX_CONF_FILE ] || exit 6     make_dirs     echo -n $"Starting $prog: "     daemon $nginx -c $NGINX_CONF_FILE     retval=$?     echo     [ $retval -eq 0 ] && touch $lockfile     return $retval } stop() {     echo -n $"Stopping $prog: "     killproc $prog -QUIT     retval=$?     echo     [ $retval -eq 0 ] && rm -f $lockfile     return $retval } restart() {     configtest || return $?     stop     sleep 1     start } reload() {     configtest || return $?     echo -n $"Reloading $prog: "     killproc $nginx -HUP     RETVAL=$?     echo } force_reload() {     restart } configtest() {   $nginx -t -c $NGINX_CONF_FILE } rh_status() {     status $prog } rh_status_q() {     rh_status >/dev/null 2>&1 } case "$1" in     start)         rh_status_q && exit 0         $1         ;;     stop)         rh_status_q || exit 0         $1         ;;     restart|configtest)         $1         ;;     reload)         rh_status_q || exit 7         $1         ;;     force-reload)         force_reload         ;;     status)         rh_status         ;;     condrestart|try-restart)         rh_status_q || exit 0             ;;     *)         echo $"Usage: $0 {start|stop|status|restart|condrestart|try-restart|reload|force-reload|configtest}"         exit 2 esac

这个脚本其实也不是我写的,谁写的呢,nginx官方写的,脚本地址:http://wiki.nginx.org/RedHatNginxInitScript ,不过要注意,如果你是自定义编译安装的nginx,需要根据您的安装路径修改下面这两项配置:

nginx=”/usr/sbin/nginx” 修改成nginx执行程序的路径。

NGINX_CONF_FILE=”/etc/nginx/nginx.conf” 修改成配置文件的路径。

保存脚本文件后设置文件的执行权限:

chmod a+x /etc/init.d/nginx

然后,就可以通过该脚本对nginx服务进行管理了:

/etc/init.d/nginx start /etc/init.d/nginx stop

使用chkconfig进行管理

上面的方法完成了用脚本管理nginx服务的功能,但是还是不太方便,比如要设置nginx开机启动等。这时可以使用chkconfig来设置。

先将nginx服务加入chkconfig管理列表:

chkconfig --add /etc/init.d/nginx

加完这个之后,就可以使用service对nginx进行启动,重启等操作了。

service nginx start service nginx stop

设置终端模式开机启动:

chkconfig nginx on

chkconfig命令的使用方法,就不多数啦,可以自行搜索



另外这里还有一个网友分享的脚本(脚本地址:http://blog.163.com/qsc0624@126/blog/static/140324073201312734548701/):

#!/bin/bash # nginx Startup script for the Nginx HTTP Server # it is v.0.0.2 version. # chkconfig: - 85 15 # description: Nginx is a high-performance web and proxy server. #              It has a lot of features, but it's not for everyone. # processname: nginx # pidfile: /var/run/nginx.pid # config: /usr/local/nginx/conf/nginx.conf nginxd=/usr/local/nginx/sbin/nginx nginx_config=/usr/local/nginx/conf/nginx.conf nginx_pid=/var/run/nginx.pid RETVAL=0 prog="nginx" # Source function library. . /etc/rc.d/init.d/functions # Source networking configuration. . /etc/sysconfig/network # Check that networking is up. [ ${NETWORKING} = "no" ] && exit 0 [ -x $nginxd ] || exit 0 # Start nginx daemons functions. start() { if [ -e $nginx_pid ];then    echo "nginx already running...."    exit 1 fi    echo -n $"Starting $prog: "    daemon $nginxd -c ${nginx_config}    RETVAL=$?    echo    [ $RETVAL = 0 ] && touch /var/lock/subsys/nginx    return $RETVAL } # Stop nginx daemons functions. stop() {         echo -n $"Stopping $prog: "         killproc $nginxd         RETVAL=$?         echo         [ $RETVAL = 0 ] && rm -f /var/lock/subsys/nginx /var/run/nginx.pid } # reload nginx service functions. reload() {     echo -n $"Reloading $prog: "     #kill -HUP `cat ${nginx_pid}`     killproc $nginxd -HUP     RETVAL=$?     echo } # See how we were called. case "$1" in start)         start         ;; stop)         stop         ;; reload)         reload         ;; restart)         stop         start         ;; status)         status $prog         RETVAL=$?         ;; *)         echo $"Usage: $prog {start|stop|restart|reload|status|help}"         exit 1 esac exit $RETVAL

使用此脚本的时候,也同样需要将配置路径修改成自己的

[转]Jquery Validate用法简介

官网地址:http://bassistance.de/jquery-plugins/jquery-plugin-validation

jQuery plugin: Validation 使用说明  

转载自:http://blog.sina.com.cn/s/blog_608475eb0100h3h1.html

 

一导入js库
<script src="../js/jquery.js" type="text/javascript"></script>
<script src="../js/jquery.validate.js" type="text/javascript"></script>

 

二、默认校验规则
(1)required:true                必输字段
(2)remote:"check.php"      使用ajax方法调用check.php验证输入值
(3)email:true                    必须输入正确格式的电子邮件
(4)url:true                        必须输入正确格式的网址
(5)date:true                      必须输入正确格式的日期 日期校验ie6出错,慎用
(6)dateISO:true                必须输入正确格式的日期(ISO),例如:2009-06-23,1998/01/22 只验证格式,不验证有效性
(7)number:true                 必须输入合法的数字(负数,小数)
(8)digits:true                    必须输入整数
(9)creditcard:                   必须输入合法的信用卡号
(10)equalTo:"#field"          输入值必须和#field相同
(11)accept:                       输入拥有合法后缀名的字符串(上传文件的后缀)
(12)maxlength:5               输入长度最多是5的字符串(汉字算一个字符)
(13)minlength:10              输入长度最小是10的字符串(汉字算一个字符)
(14)rangelength:[5,10]      输入长度必须介于 5 和 10 之间的字符串")(汉字算一个字符)
(15)range:[5,10]               输入值必须介于 5 和 10 之间
(16)max:5                        输入值不能大于5
(17)min:10                       输入值不能小于10

 

三、默认的提示
messages: {
    required: "This field is required.",
    remote: "Please fix this field.",
    email: "Please enter a valid email address.",
    url: "Please enter a valid URL.",
    date: "Please enter a valid date.",
    dateISO: "Please enter a valid date (ISO).",
    dateDE: "Bitte geben Sie ein g眉ltiges Datum ein.",
    number: "Please enter a valid number.",
    numberDE: "Bitte geben Sie eine Nummer ein.",
    digits: "Please enter only digits",
    creditcard: "Please enter a valid credit card number.",
    equalTo: "Please enter the same value again.",
    accept: "Please enter a value with a valid extension.",
    maxlength: $.validator.format("Please enter no more than {0} characters."),
    minlength: $.validator.format("Please enter at least {0} characters."),
    rangelength: $.validator.format("Please enter a value between {0} and {1} characters long."),
    range: $.validator.format("Please enter a value between {0} and {1}."),
    max: $.validator.format("Please enter a value less than or equal to {0}."),
    min: $.validator.format("Please enter a value greater than or equal to {0}.")
},

如需要修改,可在js代码中加入:

jQuery.extend(jQuery.validator.messages, {
  required: "必选字段",
  remote: "请修正该字段",
  email: "请输入正确格式的电子邮件",
  url: "请输入合法的网址",
  date: "请输入合法的日期",
  dateISO: "请输入合法的日期 (ISO).",
  number: "请输入合法的数字",
  digits: "只能输入整数",
  creditcard: "请输入合法的信用卡号",
  equalTo: "请再次输入相同的值",
  accept: "请输入拥有合法后缀名的字符串",
  maxlength: jQuery.validator.format("请输入一个 长度最多是 {0} 的字符串"),
  minlength: jQuery.validator.format("请输入一个 长度最少是 {0} 的字符串"),
  rangelength: jQuery.validator.format("请输入 一个长度介于 {0} 和 {1} 之间的字符串"),
  range: jQuery.validator.format("请输入一个介于 {0} 和 {1} 之间的值"),
  max: jQuery.validator.format("请输入一个最大为{0} 的值"),
  min: jQuery.validator.format("请输入一个最小为{0} 的值")
});

推荐做法,将此文件放入messages_cn.js中,在页面中引入
<script src="../js/messages_cn.js" type="text/javascript"></script>

 

四、使用方式
1.将校验规则写到控件中

复制代码

<script src="../js/jquery.js" type="text/javascript"></script>
<script src="../js/jquery.validate.js" type="text/javascript"></script>
<script src="./js/jquery.metadata.js" type="text/javascript"></script>

$().ready(function() {
 $("#signupForm").validate();
});


<form id="signupForm" method="get" action="">
    <p>
        <label for="firstname">Firstname</label>
        <input id="firstname" name="firstname" class="required" />
    </p>
 <p>
  <label for="email">E-Mail</label>
  <input id="email" name="email" class="required email" />
 </p>
 <p>
  <label for="password">Password</label>
  <input id="password" name="password" type="password" class="{required:true,minlength:5}" />
 </p>
 <p>
  <label for="confirm_password">确认密码</label>
  <input id="confirm_password" name="confirm_password" type="password" class="{required:true,minlength:5,equalTo:'#password'}" />
 </p>
    <p>
        <input class="submit" type="submit" value="Submit"/>
    </p>
</form>

复制代码

使用class="{}"的方式,必须引入包:jquery.metadata.js

可以使用如下的方法,修改提示内容:
class="{required:true,minlength:5,messages:{required:'请输入内容'}}"

在使用equalTo关键字时,后面的内容必须加上引号,如下代码:
class="{required:true,minlength:5,equalTo:'#password'}"

 

2.将校验规则写到js代码中

复制代码

$().ready(function() {
 $("#signupForm").validate({
        rules: {
   firstname: "required",
   email: {
    required: true,
    email: true
   },
   password: {
    required: true,
    minlength: 5
   },
   confirm_password: {
    required: true,
    minlength: 5,
    equalTo: "#password"
   }
  },
        messages: {
   firstname: "请输入姓名",
   email: {
    required: "请输入Email地址",
    email: "请输入正确的email地址"
   },
   password: {
    required: "请输入密码",
    minlength: jQuery.format("密码不能小于{0}个字 符")
   },
   confirm_password: {
    required: "请输入确认密码",
    minlength: "确认密码不能小于5个字符",
    equalTo: "两次输入密码不一致不一致"
   }
  }
    });
});

复制代码

//messages处,如果某个控件没有message,将调用默认的信息

复制代码

<form id="signupForm" method="get" action="">
    <p>
        <label for="firstname">Firstname</label>
        <input id="firstname" name="firstname" />
    </p>
 <p>
  <label for="email">E-Mail</label>
  <input id="email" name="email" />
 </p>
 <p>
  <label for="password">Password</label>
  <input id="password" name="password" type="password" />
 </p>
 <p>
  <label for="confirm_password">确认密码</label>
  <input id="confirm_password" name="confirm_password" type="password" />
 </p>
    <p>
        <input class="submit" type="submit" value="Submit"/>
    </p>
</form>

复制代码

 

required:true 必须有值
required:"#aa:checked"表达式的值为真,则需要验证
required:function(){}返回为真,表时需要验证
后边两种常用于,表单中需要同时填或不填的元素

 

五、常用方法及注意问题
1.用其他方式替代默认的SUBMIT
$().ready(function() {
 $("#signupForm").validate({
        submitHandler:function(form){
            alert("submitted");   
            form.submit();
        }    
    });
});

使用ajax方式

 $(".selector").validate({     
 submitHandler: function(form) 
   {      
      $(form).ajaxSubmit();     
   }  
 }) 

可以设置validate的默认值,写法如下:
$.validator.setDefaults({
 submitHandler: function(form) { alert("submitted!");form.submit(); }
});

如果想提交表单, 需要使用form.submit()而不要使用$(form).submit()

2.debug,只验证不提交表单
如果这个参数为true,那么表单不会提交,只进行检查,调试时十分方便

$().ready(function() {
 $("#signupForm").validate({
        debug:true
    });
});
如果一个页面中有多个表单都想设置成为debug,用
$.validator.setDefaults({
   debug: true
})

3.ignore:忽略某些元素不验证
ignore: ".ignore"
4.更改错误信息显示的位置
errorPlacement:Callback

 Default: 把错误信息放在验证的元素后面 
指明错误放置的位置,默认情况是:error.appendTo(element.parent());即把错误信息放在验证的元素后面 
errorPlacement: function(error, element) {  
    error.appendTo(element.parent());  
}

//示例:

复制代码

<tr>
    <td class="label"><label id="lfirstname" for="firstname">First Name</label></td>
    <td class="field"><input id="firstname" name="firstname" type="text" value="" maxlength="100" /></td>
    <td class="status"></td>
</tr>
<tr>
    <td style="padding-right: 5px;">
        <input id="dateformat_eu" name="dateformat" type="radio" value="0" />
        <label id="ldateformat_eu" for="dateformat_eu">14/02/07</label>
    </td>
    <td style="padding-left: 5px;">
        <input id="dateformat_am" name="dateformat" type="radio" value="1"  />
        <label id="ldateformat_am" for="dateformat_am">02/14/07</label>
    </td>
    <td></td>
</tr>
<tr>
    <td class="label">&nbsp;</td>
    <td class="field" colspan="2">
        <div id="termswrap">
            <input id="terms" type="checkbox" name="terms" />
            <label id="lterms" for="terms">I have read and accept the Terms of Use.</label>
        </div>
    </td>
</tr>

errorPlacement: function(error, element) {
    if ( element.is(":radio") )
        error.appendTo( element.parent().next().next() );
    else if ( element.is(":checkbox") )
        error.appendTo ( element.next() );
    else
        error.appendTo( element.parent().next() );
}

复制代码

代码的作用是:一般情况下把错误信息显示在<td class="status"></td>中,如果是radio显示在<td></td>中,如果是 checkbox显示在内容的后面

errorClass:String  Default: "error" 
指定错误提示的css类名,可以自定义错误提示的样式

errorElement:String  Default: "label" 
用什么标签标记错误,默认的是label你可以改成em

errorContainer:Selector 
显示或者隐藏验证信息,可以自动实现有错误信息出现时把容器属性变为显示,无错误时隐藏,用处不大
errorContainer: "#messageBox1, #messageBox2"

errorLabelContainer:Selector
把错误信息统一放在一个容器里面。

wrapper:String
用什么标签再把上边的errorELement包起来

一般这三个属性同时使用,实现在一个容器内显示所有错误提示的功能,并且没有信息时自动隐藏

errorContainer: "div.error",
errorLabelContainer: $("#signupForm div.error"),
wrapper: "li"

5更改错误信息显示的样式
设置错误提示的样式,可以增加图标显示,在该系统中已经建立了一个validation.css专门用于维护校验文件的样式

 

input.error { border: 1px solid red; }
label.error {
  background:url("./demo/images/unchecked.gif") no-repeat 0px 0px;

  padding-left: 16px;

  padding-bottom: 2px;

  font-weight: bold;

  color: #EA5200;
}
label.checked {
  background:url("./demo/images/checked.gif") no-repeat 0px 0px;
}

6每个字段验证通过执行函数
success:String,Callback
要验证的元素通过验证后的动作,如果跟一个字符串,会当做一个css类,也可跟一个函数
success: function(label) {
    // set &nbsp; as text for IE
    label.html("&nbsp;").addClass("checked");
    //label.addClass("valid").text("Ok!")
}
添加"valid" 到验证元素, 在CSS中定义的样式<style>label.valid {}</style>
success: "valid"

 

7验证的触发方式修改
下面的虽然是boolean型的,但建议除非要改为false,否则别乱添加。

onsubmit:Boolean  Default: true 
提交时验证. 设置唯false就用其他方法去验证
onfocusout:Boolean  Default: true 
失去焦点是验证(不包括checkboxes/radio buttons)
onkeyup:Boolean  Default: true 
在keyup时验证.
onclick:Boolean  Default: true 
在checkboxes 和 radio 点击时验证
focusInvalid:Boolean  Default: true 
提交表单后,未通过验证的表单(第一个或提交之前获得焦点的未通过验证的表单)会获得焦点
focusCleanup:Boolean  Default: false 
如果是true那么当未通过验证的元素获得焦点时,移除错误提示。避免和 focusInvalid 一起用

 

// 重置表单
$().ready(function() {
 var validator = $("#signupForm").validate({
        submitHandler:function(form){
            alert("submitted");   
            form.submit();
        }    
    });
    $("#reset").click(function() {
        validator.resetForm();
    });

});

8异步验证
remote:URL
使用ajax方式进行验证,默认会提交当前验证的值到远程地址,如果需要提交其他的值,可以使用data选项

remote: "check-email.php"

remote: {
    url: "check-email.php",     //后台处理程序
    type: "post",               //数据发送方式
    dataType: "json",           //接受数据格式   
    data: {                     //要传递的数据
        username: function() {
            return $("#username").val();
        }
    }
}


远程地址只能输出 "true" 或 "false",不能有其它输出

 

9添加自定义校验
addMethod:name, method, message
自定义验证方法


// 中文字两个字节
jQuery.validator.addMethod("byteRangeLength", function(value, element, param) {
    var length = value.length;
    for(var i = 0; i < value.length; i++){
        if(value.charCodeAt(i) > 127){
            length++;
        }
    }
  return this.optional(element) || ( length >= param[0] && length <= param[1] );   
}, $.validator.format("请确保输入的值在{0}-{1}个字节之间(一个中文字算2个字节)"));


// 邮政编码验证   
jQuery.validator.addMethod("isZipCode", function(value, element) {   
    var tel = /^[0-9]{6}$/;
    return this.optional(element) || (tel.test(value));
}, "请正确填写您的邮政编码");

 

1.要在additional-methods.js文件中添加或者在jquery.validate.js添加
建议一般写在additional-methods.js文件中

2.在messages_cn.js文件添加:isZipCode: "只能包括中文字、英文字母、数字和下划线",

调用前要添加对additional-methods.js文件的引用。

 

 

10radio和checkbox、select的验证
 

1.radio的required表示必须选中一个
<input  type="radio" id="gender_male" value="m" name="gender" class="{required:true}" />
<input  type="radio" id="gender_female" value="f" name="gender"/>

 

2.checkbox的required表示必须选中
<input type="checkbox" class="checkbox" id="agree" name="agree" class="{required:true}" />

checkbox的minlength表示必须选中的最小个数,maxlength表示最大的选中个数,rangelength:[2,3]表 示选中个数区间


<input type="checkbox" class="checkbox" id="spam_email" value="email" name="spam[]" class="{required:true, minlength:2}" />
<input type="checkbox" class="checkbox" id="spam_phone" value="phone" name="spam[]" />
<input type="checkbox" class="checkbox" id="spam_mail" value="mail" name="spam[]" />

 

    3.select的required表示选中的value不能为空
<select id="jungle" name="jungle" title="Please select something!" class="{required:true}">
    <option value=""></option>
    <option value="1">Buga</option>
    <option value="2">Baga</option>
    <option value="3">Oi</option>
</select>

 

select的minlength表示选中的最小个数(可多选的select),maxlength表示最大的选中个 数,rangelength:[2,3]表示选中个数区间
<select id="fruit" name="fruit" title="Please select at least two fruits" class="{required:true, minlength:2}" multiple="multiple">
    <option value="b">Banana</option>
    <option value="a">Apple</option>
    <option value="p">Peach</option>
    <option value="t">Turtle</option>
</select>

 

 

jQuery.validate 中文API   


名称


返回类型


描述


validate(options)


返回:Validator


验证所选的FORM


valid()


返回:Boolean


检查是否验证通过


rules()


返回:Options


返回元素的验证规则


rules("add",rules)


返回:Options


增加验证规则


rules("remove",rules)


返回:Options


删除验证规则


removeAttrs(attributes)


返回:Options


删除特殊属性并且返回他们


Custom selectors


:blank


返回:Validator


没有值的筛选器


:filled


返回:Array <Element 
>


有值的筛选器


:unchecked


返回:Array <Element 
>


没选择的元素的筛选器


Utilities


jQuery.format


(template,argument 
,argumentN...)


返回:String


用参数代替模板中的 
{n}



Validator:


validate方法返回一个Validator对象,它有很多方法, 让你能使用引发校验程序或者改变form的内容. validator对象有很多方法,但下面只是列出常用的


form()


返回:Boolean


验证form返回成功还是失败


element(element)


返回:Boolean


验证单个元素是成功还是失败


resetForm()


返回:undefined


把前面验证的FORM恢复到验证前原来的状态


showErrors(errors)


返回:undefined


显示特定的错误信息


Validator functions:


setDefaults(defaults)


返回:undefined


改变默认的设置


addMethod(name,method,message)


返回:undefined


添加一个新的验证方法. 必须包括一个独一无二的名字,一个JAVASCRIPT的方法和一个默认的信息


addClassRules(name,rules)


返回:undefined


增加组合验证类型 在一个类里面用多种验证方法里比较有用


addClassRules(rules)


返回:undefined


增加组合验证类型 在一个类里面用多种验证方法里比较有用,这个是一下子加多个



内置验证方式:


required()


返回:Boolean


必填验证元素


required(dependency-expression)


返回:Boolean


必填元素依赖于表达式的结果


required(dependency-callback)


返回:Boolean


必填元素依赖于回调函数的结果


remote(url)


返回:Boolean


请求远程校验。url通常是一个远程调用方法


minlength(length)


返回:Boolean


设置最小长度


maxlength(length)


返回:Boolean


设置最大长度


rangelength(range)


返回:Boolean


设置一个长度范围[min,max]


min(value)


返回:Boolean


设置最大值


max(value)


返回:Boolean


设置最小值


email()


返回:Boolean


验证电子邮箱格式


range(range)


返回:Boolean


设置值的范围


url()


返回:Boolean


验证URL格式


date()


返回:Boolean


验证日期格式(类似30/30/2008的格式,不验证日期准确性只验证格式)


dateISO()


返回:Boolean


验证ISO类型的日期格式


dateDE()


返回:Boolean


验证德式的日期格式(29.04.1994 or 
1.1.2006)


number()


返回:Boolean


验证十进制数字(包括小数的)


digits()


返回:Boolean


验证整数


creditcard()


返回:Boolean


验证信用卡号


accept(extension)


返回:Boolean


验证相同后缀名的字符串


equalTo(other)


返回:Boolean


验证两个输入框的内容是否相同


phoneUS()


返回:Boolean


验证美式的电话号码



validate ()的可选项:


debug:进行调试模式(表单不提交):


$(".selector").validate


({


   debug:true


})


把调试设置为默认:


$.validator.setDefaults({


   debug:true


})


submitHandler:


通过验证后运行的函数,里面要加上表单提交的函数,否则表单不会提交


$(".selector").validate({


   submitHandler:function(form) 
{


$(form).ajaxSubmit();


   }


})


ignore:


对某些元素不进行验证


$("#myform").validate({


   ignore:".ignore"


})


rules:


自定义规则,key:value的形式,key是要验证的元素,value可以是字符串或对象


$(".selector").validate({


   rules:{


     name:"required",


     email:{


       required:true,


       email:true


     }


   }


})


messages:


自定义的提示信息key:value的形式key是要验证的元素,值是字符串或函数


$(".selector").validate({


   rules:{


     name:"required",


     email:{


       required:true,


       email:true


     }


   },


   messages:{


     name:"Name不能为空",


     email:{


       
required:"E-mail不能为空",


       email:"E-mail地址不正确"


     }


   }


})


groups:


对一组元素的验证,用一个错误提示,用error Placement控制把出错信息放在哪里


$("#myform").validate({


  groups:{


    username:"fname 
lname"


  },


  
errorPlacement:function(error,element) {


     if (element.attr("name") == 
"fname" || element.attr("name") == "lname")


       
error.insertAfter("#lastname");


     else


       
error.insertAfter(element);


   },


   debug:true


})


Onubmit Boolean 默认:true


是否提交时验证


$(".selector").validate({


   
onsubmit:false


})


onfocusout Boolean 默认:true  


是否在获取焦点时验证


$(".selector").validate({


   
onfocusout:false


})


onkeyup Boolean 默认:true  


是否在敲击键盘时验证


$(".selector").validate({


   onkeyup:false


})


onclick Boolean 默认:true


是否在鼠标点击时验证(一般验证checkbox,radiobox)


$(".selector").validate({


   onclick:false


})


focusInvalid Boolean 默认:true


提交表单后,未通过验证的表单(第一个或提交之前获得焦点的未通过验证的表单)会获得焦点


$(".selector").validate({


   focusInvalid:false


})


focusCleanup Boolean 默认:false


当未通过验证的元素获得焦点时,并移除错误提示(避免和 focusInvalid.一起使用)


$(".selector").validate({


   focusCleanup:true


})


errorClass String 默认:"error"


指定错误提示的css类名,可以自定义错误提示的样式


$(".selector").validate({


   
errorClass:"invalid"


})


errorElement String 默认:"label"


使用什么标签标记错误


$(".selector").validate


   errorElement:"em"


})


wrapper String


使用什么标签再把上边的errorELement包起来


$(".selector").validate({


   wrapper:"li"


})


errorLabelContainer Selector


把错误信息统一放在一个容器里面


$("#myform").validate({


   
errorLabelContainer:"#messageBox",


   wrapper:"li",


   submitHandler:function() { 
alert("Submitted!") }


})



showErrors:


跟一个函数,可以显示总共有多少个未通过验证的元素


$(".selector").validate({


   
showErrors:function(errorMap,errorList) {


        $("#summary").html("Your 
form contains " + this.numberOfInvalids() + " errors,see details 
below.");


        
this.defaultShowErrors();


   }


})


errorPlacement:


跟一个函数,可以自定义错误放到哪里


$("#myform").validate({


  
rrorPlacement:function(error,element) {  
error.appendTo(element.parent("td").next("td"));


   },


   debug:true



})


success:


要验证的元素通过验证后的动作,如果跟一个字符串,会当做一个css类,也可跟一个函数


$("#myform").validate({


        
success:"valid",


        submitHandler:function() 
{ alert("Submitted!") }


})


highlight:


可以给未通过验证的元素加效果,闪烁等




addMethod(name,method,message)方法:


参数name是添加的方法的名字


参数method是一个函数,接收三个参数(value,element,param) 
value是元素的值,element是元素本身 
param是参数,我们可以用addMethod来添加除built-in Validation 
methods之外的验证方法 比如有一个字段,只能输一个字母,范围是a-f,写法如下:



$.validator.addMethod("af",function(value,element,params){


   
if(value.length>1){


    return false;


   }


   if(value>=params[0] 
&& value<=params[1]){


    return true;


   }else{


    return false;


   }


},"必须是一个字母,且a-f");


用的时候,比如有个表单字段的id="username",则在rules中写


username:{


   af:["a","f"]


}



addMethod的第一个参数,就是添加的验证方法的名子,这时是af


addMethod的第三个参数,就是自定义的错误提示,这里的提示为:"必须是一个字母,且a-f"


addMethod的第二个参数,是一个函数,这个比较重要,决定了用这个验证方法时的写法


如果只有一个参数,直接写,如果af:"a",那么a就是这个唯一的参数,如果多个参数,用在[]里,用逗号分开



meta String方式:


$("#myform").validate({


   meta:"validate",


   submitHandler:function() { 
alert("Submitted!") }


})


<script type="text/javascript" 
src="js/jquery.metadata.js"></script>


<script type="text/javascript" 
src="js/jquery.validate.js"></script>


<form id="myform">


  <input type="text" 
name="email" class="{validate:{ required:true,email:true }}" />


  <input type="submit" 
value="Submit" />


</form>

lnmp 下载与安装

wget --no-check-certificate https://api.sinas3.com/v1/SAE_lnmp/soft/lnmp1.2-full.tar.gz

数据库中INFORMATION_SCHEMA的说明及使用

第一个查询看看库里有多少个表,表名等
select * from INFORMATION_SCHEMA.TABLES

information_schema 这张数据表保存了MySQL服务器所有数据库的信息。如数据库名,数据库的表,表栏的数据类型与访问权限等。再简单点,这台MySQL服务器上,到底有哪 些数据库、各个数据库有哪些表,每张表的字段类型是什么,各个数据库要什么权限才能访问,等等信息都保存在information_schema表里面。

Mysql的INFORMATION_SCHEMA数据库包含了一些表和视图,提供了访问数据库元数据的方式。

元数据是关于数据的数据,如数据库名或表名,列的数据类型,或访问权限等。有些时候用于表述该信息的其他术语包括“数据词典”和“系统目录”。

 

下面对一些重要的数据字典表做一些说明:

SCHEMATA表:提供了关于数据库的信息。

TABLES表:给出了关于数据库中的表的信息。

COLUMNS表:给出了表中的列信息。

STATISTICS表:给出了关于表索引的信息。

USER_PRIVILEGES表:给出了关于全程权限的信息。该信息源自mysql.user授权表。

SCHEMA_PRIVILEGES表:给出了关于方案(数据库)权限的信息。该信息来自mysql.db授权表。

TABLE_PRIVILEGES表:给出了关于表权限的信息。该信息源自mysql.tables_priv授权表。

COLUMN_PRIVILEGES表:给出了关于列权限的信息。该信息源自mysql.columns_priv授权表。

CHARACTER_SETS表:提供了关于可用字符集的信息。

COLLATIONS表:提供了关于各字符集的对照信息。

COLLATION_CHARACTER_SET_APPLICABILITY表:指明了可用于校对的字符集。

TABLE_CONSTRAINTS表:描述了存在约束的表。

KEY_COLUMN_USAGE表:描述了具有约束的键列。

ROUTINES表:提供了关于存储子程序(存储程序和函数)的信息。此时,ROUTINES表不包含自定义函数(UDF)。

VIEWS表:给出了关于数据库中的视图的信息。

TRIGGERS表:提供了关于触发程序的信息。

批量生成dbtable Zend framework 笔记



Zend framework等主流框架中一个数据表对应一个dbtable ,代码格式相似,可以利用php fopen函数自动生成

核心代码
$sql="SELECT TABLE_NAME,TABLE_COMMENT FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = '".$db."'";
INFORMATION_SCHEMA.TABLES这张数据表保存了MySQL服务器所有数据库的信息,是MySQL的提供的数据库管理信息详情请转到
$db 就是接下来需要操作的数据库的名字 执行mysqli_fetch_all后返回一个一维数组

$txt='<?php  namespace ..............'
        $dbtablename = $dbtablename[$row['TABLE_NAME']].".php";
        $myfile = fopen($dbtablename , "w");
        fwrite($myfile, $txt);


以下为事例代码
<?php

$con = mysqli_connect();
if (!$con)
  {
  die('Could not connect: ' . mysql_error());
  }
$db = $_GET['db'];
$sql="SELECT TABLE_NAME,TABLE_COMMENT FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA = '".$db."'";

$result=mysqli_query($con,$sql);
$data = mysqli_fetch_all($result,MYSQLI_ASSOC);

function stre($string)
{
    $res = $string;
    foreach(range('a','z') as $v){
    $bv=strtoupper($v);
    $bere = "_".$v;
    $re ="_".$bv;
    $res = str_replace($bere,$re,$res);
    }
    return $res;
}
$dbtablename = array();
foreach ($data as $row ) {
    $dbtablename[$row['TABLE_NAME']] = str_replace("_","",str_replace("dl_","",stre($row['TABLE_NAME'])));
    $dbtablenamestring[$row['TABLE_NAME']] =    str_replace("dl_","",$row['TABLE_NAME']);   
        $txt='
<?php

namespace Model\Db;

use GatewayWorker\Lib\DbTable;
    /*
    * '.$row ["TABLE_COMMENT"].'
    */
class AppFeedback extends DbTable{

    protected $_name = "'.$dbtablenamestring[$row['TABLE_NAME']].'";

    protected $_primary = "id";

    protected $_db = "'.$db.'";

    /*
    * 构造函数
    */
    public function __construct(){
      
    }


    }   
        ';   
        $lastname = $dbtablename[$row['TABLE_NAME']].".php";
        $myfile = fopen($lastname, "w");
        fwrite($myfile, $txt);
}
  mysqli_close($con);
?>

ElasticSearch入门笔记

ElasticSearch 是构建在Apache Lucene之上的的搜索引擎服务,开源(Apache2协议),分布式,RESTful。安装方便,使用简单。

官方站点:http://www.elasticsearch.com/
中文站点:http://es-cn.medcl.net/

1.安装

必须先安装Java环境,并设置 JAVA_HOME => C:\Program Files\Java\jdk1.6.0_18

elasticsearch-rtf 中文入门集成包 https://github.com/medcl/elasticsearch-rtf
使用git签出,下载到本地。windows下,执行bin下面的elasticsearch.bat。linux下,执行bin下面或者service下面elasticsearch。

Pyes https://github.com/aparo/pyes 更多客户端

Bottle http://bottlepy.org/docs/dev/

2.角色关系对照

elasticsearch 跟 MySQL 中定义资料格式的角色关系对照表如下

MySQL             elasticsearch
database                 index
table                         type

table schema mapping
row                          document
field                         field

3.索引映射

#创建索引
$ curl -XPUT http://localhost:9200/test-index

#创建Mapping
$ curl -XPUT http://localhost:9200/test-index/test-type/_mapping -d '{
    "properties" : {
        "name" : { "type" : "string" }
    }
}'

@route('/indexsetting/')
def indexmapping():
    """索引映射"""
    conn = ES('127.0.0.1:9200')
    conn.debug_dump = True
    try:
        #删除索引
        conn.delete_index("test-index")
    except:
        pass
    #创建索引
    conn.create_index("test-index")
    mapping = {
           u'id': {'store': 'yes',
                    'type': u'integer'},
           u'author': {'boost': 1.0,
                       'index': 'not_analyzed',
                       'store': 'yes',
                       'type': u'string'},
           u'published': {'boost': 1.0,
                          'index': 'not_analyzed',
                          'store': 'yes',
                          'type': u'datetime'},
           u'url': {'store': 'yes',
                    'type': u'string'},
           u'title': {'boost': 1.0,
                       'index': 'analyzed',
                       'store': 'yes',
                       'type': u'string'},
           u'content': {'boost': 1.0,
                       'index': 'analyzed',
                       'store': 'yes',
                       'type': u'string',
                       "term_vector" :"with_positions_offsets"}
           }
    #索引映射
    conn.put_mapping("test-type", {'properties':mapping},["test-index"])
    return "索引映射"

4.索引

#索引
$ curl -XPUT http://localhost:9200/test-index/test-type/1 -d '{
    "user": "kimchy",
    "post_date": "2009-11-15T13:12:00",
    "message": "Trying out elasticsearch, so far so good?"
}'

#获取
$ curl -XGET http://localhost:9200/test-index/test-type/1

#删除
$ curl -XDELETE 'http://localhost:9200/test-index/test-type/1'

@route('/indextest/')
def indexTest():
    """索引测试"""
    conn = ES('127.0.0.1:9200')
    for item in Data().getData():
        #添加索引
        conn.index(item,"test-index", "test-type",item['id'])

    #索引优化
    conn.optimize(["test-index"])
    #删除索引内容
    conn.delete("test-index", "test-type", 2668090)
    #更新索引内容
    model = conn.get("test-index", "test-type", 2667371)
    model["title"]="标题修改测试"
    conn.update(model,"test-index", "test-type",2667371)

    #刷新索引
    conn.refresh(["test-index"])

    q = MatchAllQuery()
    results = conn.search(query = q,indices="test-index",doc_types="test-type")
#    for r in results:
#        print r
    return template('default.tpl',list=results,count=len(results))

5.搜索

#lucene语法方式的查询
$ curl -XGET http://localhost:9200/test-index/test-type/_search?q=user:kimchy

#query DSL方式查询
$ curl -XGET http://localhost:9200/test-index/test-type/_search-d '{
    "query" : {
        "term" : { "user": "kimchy" }
    }
}'

#query DSL方式查询
$ curl -XGET http://localhost:9200/test-index/_search?pretty=true -d '{
    "query" : {
        "range" : {
            "post_date" : {
                "from" : "2009-11-15T13:00:00",
                "to" : "2009-11-15T14:30:00"
            }
        }
    }
}'

#查找全部索引内容
$ curl -XGET http://localhost:9200/test-index/test-type/_search?pretty=true

@route('/search/')
@route('/search/<searchkey>')
def search(searchkey=u"关键算法"):
    """索引搜索"""
    conn = ES('127.0.0.1:9200')

    #TextQuery会对searchkey进行分词
    qtitle = TextQuery("title", searchkey)
    qcontent = TextQuery("content", searchkey)
    #发布时间大于"2012-9-2 22:00:00"
    qpublished=RangeQuery(ESRangeOp("published", "gt",datetime(2012, 9, 2, 22, 0, 0)))

    h = HighLighter(['<b>'], ['</b>'], fragment_size=500)
    #多字段搜索(must=>and,should=>or),高亮,结果截取(分页),排序
    q =Search(BoolQuery(must=[qpublished],should=[qtitle,qcontent]),highlight=h, start=0, size=3, sort={'id': {'order': 'asc'}})
    q.add_highlight("title")
    q.add_highlight("content")
    results = conn.search(query = q,indices="test-index",doc_types="test-type")

    list=[]
    for r in results:
        if(r._meta.highlight.has_key("title")):
            r['title']=r._meta.highlight[u"title"][0]
        if(r._meta.highlight.has_key("content")):
            r['content']=r._meta.highlight[u"content"][0]
        list.append(r)
    return template('search.tpl',list=list,count=results.total)
</searchkey>

6.设置

#创建索引,并设置分片和副本参数
$ curl -XPUT http://localhost:9200/elasticsearch/ -d '{
    "settings" : {
        "number_of_shards" : 2,
        "number_of_replicas" : 3
    }
}'

7.其他

#分词
curl -XGET 'http://localhost:9200/test-index/_analyze?text=中华人民共和国'

例子程序下载

来源: http://www.qwolf.com/?p=1387

Linux系统下文件的上传与下载命令

http://lupingui.iteye.com/blog/239694

linux系统下可以直接从客户端上传文件到服务器端,命令格式:

[plain] view plain copy

  1. scp files user@server:filepath  

解释:

files 待上传的文件,可以有多个,多个文件之间用空格隔开。也可以用*.filetype上传某个类型的全部文件

user 服务端登录用户名

server 服务器名(IP或域名)

filepath 上传到服务器的目标路径(这里注意此用户一定要有这个路径的读写权限)

 

如果从其它linux系统下载文件到本地可以用:

[plain] view plain copy

  1. scp user@server:files client_file_path  

解释:

user 服务端登录用户名

server 服务器名(IP或域名)

files 待下载的文件

client_file_path 下载到本地的存放路径

 

linux系统下也可以直接用命令形式从网上下载文件,命令格式:

[plain] view plain copy

  1. lftp -c "pget -n 5 http://downpath"  

解释:

lftp 文件下载命令,通过ftp通道传输

pget -n 5 O也不清楚这里的意义 -_-

http://downpath 待下载文件的连接地址

 

这二个方法的传输速度都比较快,所以记录下来以供参考。

Linux ssh scp 基本格式

2007-12-29 15:26

ssh:

ssh -l username   -p port   hostname or IP

如: ssh -l kevin_u -p 22 192.168.1.1

scp:

上传一个文件


scp -P port localfilepath useranme@hostmname or ip: remotefilepath

如:scp -P 22 aa.txt kevin_u@192.168.1.1:/tmp

下载一个文件

scp -P 22 username@hostname or ip:remotefilepath or ip:remotefilepath localfilepath

如:scp -P 22 kevin_u@192.168.1.1:/tmp/aa.txt ./

Linux查看磁盘空间命令


2013年04月08日 ⁄ CentOS, Linux ⁄ 共 530字 ⁄ 字号 暂无评论 ⁄ 阅读 13,250 次

本文主要介绍Linux下查看磁盘、文件夹空间命令。

首先如果需要查看整个磁盘还剩多少空间,可以使用命令df -h。

1df -h

如果你并不关心磁盘还剩余多少空间,只是需要知道当前的文件夹下的磁盘使用情况,可以使用如下命令:

1du --max-depth=1 -h

上面使用du --max-depth=1 -h命令来查找磁盘的使用情况,默认是当前的路径。

其中-h参数是为了方便你读懂每个文件的大小,如果没有这个参数显示的文件大小就没有k,M,G等。

得到结果中,前面n-1行的是该目录下每个文件夹的大小。最后一行显示的是该目录总的大小。

如果你并不关心该目录下每个文件的大小,你只想知道其中某一个文件(文件夹)的大小,需要使用下面命令:

1du -sh

聪明的你一定发现了这里显示的大小和上面最后一行的大小是一样的。

还有另外一个命令,也可以得到得到同样的效果:

1du -h --max-depth=0

其实在man手册里面已经告诉了我们:--max-depth=0的功能和-s的功能是一样的。

另外du命令后面可以跟文件路径,来查看指定路径的大小:

1du -sh /root/sw